#include <stdio.h>
#include <string.h>
#include <pthread.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/time.h> 
// #include <netinet/ip_icmp.h>
#include <termios.h>

//globale Variablen  	
#define MAXHOPS 15
#define LQNLQFLAG 1
#define ETXFLAG 2
#define PINGIPFLAG 4
#define MAINIPFLAG 8
#define NAMEFLAG 0x10
#define GEOFLAG 0x20
#define BROADCASTFLAG 0x40
// #define
#define OLSRDFLAG 0x200
// #define
#define TERMINALFLAG 0x1000
#define SCREENFLAG 0x2000
#define FILEFLAG 0x4000
#define DEBUGFLAG 0x8000

// next 2 structs taken from: <netinet/ip_icmp.h> (part of the GNU C Library.)
// Copyright (C) 1991,92,93,95,96,97,98,99,2000 Free Software Foundation, Inc.


struct icmphdr 
{
  u_int8_t type;		/* message type */
  u_int8_t code;		/* type sub-code */
  u_int16_t checksum;
  union
  {
    struct
    {
      u_int16_t	id;
      u_int16_t	sequence;
    } echo;			/* echo datagram */
    u_int32_t	gateway;	/* gateway address */
    struct
    {
      u_int16_t	__unused;  //if compiler says: doesnt declare anything!
      u_int16_t	mtu;
// 			u_int32_t	mtu;
    } frag;			/* path mtu discovery */
  } un;
};

struct iphdr
  {
#if __BYTE_ORDER == __LITTLE_ENDIAN
    unsigned int ihl:4;
    unsigned int version:4;
#elif __BYTE_ORDER == __BIG_ENDIAN
    unsigned int version:4;
    unsigned int ihl:4;
#else
# error	"Please fix <bits/endian.h>"
#endif
    u_int8_t tos;
    u_int16_t tot_len;
    u_int16_t id;
    u_int16_t frag_off;
    u_int8_t ttl;
    u_int8_t protocol;
    u_int16_t check;
    u_int32_t saddr;
    u_int32_t daddr;
  };

struct node {long int ip; int flag; int ali; };
struct verwaltung { unsigned long int Ziel; int id; int icmpsock; unsigned int seq; int flag; unsigned short int param; int ppid; };
struct alibaba{ unsigned long int pingip; unsigned long int mainip; char name[25];int midttl; unsigned short nodeposindex;};
//  float longitude; float latitude;};
struct paar{ int ip1; int ip2; unsigned short int lq; unsigned short int nlq; unsigned int counter; unsigned int used;};
struct statistic{ unsigned int lqsum; unsigned int nlqsum; unsigned int lqsumsq; unsigned int nlqsumsq; unsigned int counter;};
struct nodepos {unsigned long int IP; float  longitude; float latitude;};

struct node Pingliste[MAXHOPS ]; 	// liste der ping antworten
struct verwaltung Verwaltung;		// liste mit meta-infos
struct statistic *Statistic;		// liste mit statistic-infos
struct alibaba *Alibaba;		// liste der bekannten knoten
int hoehle, raeuber;			// groesze der liste, anzahl der eintraege
struct nodepos *Nodepos;
int Menge;
struct paar *Paare;			//liste der bekannten hops
int Air, Luftloecher;			//groesze der liste, anzahl der eintraege
short int Route[MAXHOPS];		//Liste der aktuellen route mit paarindizes
float etxmap[256][256];
char *hostdatei;
char *alidatei;
int returned_pings;
int(*Output)(void);
int(*Input)(void);


//Funktionen
int Udpfunktion();				/*lauscht auf olsr-pakete*/
int Pfadfinder();				/*sendet pings*/
unsigned short checksum (unsigned short *puffer, int worte);
						/*calcs i(cm)p checksums*/
int Horcher();					/*lauscht auf Ping-antworten*/
int Schreiber();				/*pflegt die listen*/
int Chronist();					/*schreibt regelmäßig stand der dinge auf den bildschirm*/
void initial(void);				/*initialises (or flushes) the lists*/
int set_input_mode();				/*checks for terminal, saves and sets atributes */
int key_stroke_listen(char c);
int dummyfunc();				/* does nothing but returning 0*/
int txtsock();
void remove_fftrace_tmpfiles();
