 // Quadratwurzel-Funktion
 // wofür?...
 // was tut es: Quadratwurzel mit Heron-alg. berechnen
 // gpl
 // von hørst nach Wikipedia-Artikel 
 
 float Wurzel(float Input) 
 { 
 
 // float number in ihren 32 Bits:                           // http://de.wikipedia.org/wiki/Gleitkommazahl
 // b    bbbbbbbb        bbbbbbbbbbbbbbbbbbbbbbb 
 // Vorzeichen
 //      Exponent+127(Bias)
 //                      Mantisse als ganze Zahl
 //                      (Mantisse /(2^Exponent) -1)*2^23     
 
 // Variablen
 
 unsigned long int *Maske;                                   // Maske, um die Bits direkt zu manipulieren
 unsigned short int Exponent;                                // Exponenten-Zwischenlager
 float Wurzel = 1;                                           // Startwert und Endspeicher
 short int i;
 Maske = (unsigned long int *)&Input;                        // Maske auflegen 
 
/* if (*Maske >>31 == 1)                                       // Vorzeichentest
 {	*Maske = 0x7fffffff;
        return Input;}
 // Bei negativem Input wird abgebrochen, und die für 
 // "nan" -> "not a number" reservierte Bitfolge 
 // zurückgegeben
 */
 if ((*Maske &0xffffff) == 0x7fffff) *Maske +=1;             // Extremfall-Korrektur
 // Die Iteration versagt bei ungeradem Exponent
 // und einer Mantisse die binär 
 // ausschliesslich aus Einsen besteht.(overflow)
 // Wurzel aus "fast 1" wäre unkorrigiert = 0.75 
 
 Exponent = *Maske>>23;                                      // Exponent abspeichern 
 // *Maske:      bBBBBBBBBbbbbbbbbbbbbbbbbbbbbbbb
 // *Maske>>23:                         bBBBBBBBB(bbbbbbbbbbbbbbbbbbbbbbb)
 // Exponent =                   00000000BBBBBBBB
 // Es sind nur die großen "B"-Bits der Exponent,
 // die kleinen "b" sind Mantisse und Vorzeichen (s.o.).
 // Eine Bitverschiebung um 23 Bits nach rechts,
 // schneidet gerade die Mantisse ab.
 // Ob das Vorzeichenbit == 0 ist wurde schon geprüft.
 // Der Exponent wurde als "short unsigned int"
 // deklariert, und hat darum nur 16-Bits
 
 *Maske=((*Maske|0xff000000) &0x3fffffff);                     // einen geraden Anteil vom Exponent abspalten
 // *Maske:      bBBBBBBBBbbbbbbbbbbbbbbbbbbbbbbb
 // |0xff000000: 11111111000000000000000000000000
 // &0x3fffffff: 00111111111111111111111111111111
 // *Maske=      00111111Bbbbbbbbbbbbbbbbbbbbbbbb
 // 
 // Die Bitweise ODER-Verknüpfung mit Hex:ff000000
 // setzt die ersten acht Bit auf Eins, und lässt
 // das letzte Bit des Exponenten, 
 // sowie die Mantisse intakt.
 // Die Bitweise UND-Verknüpfung mit Hex:3fffffff
 // setzt die ersten beiden Bits auf Null.
 // Der Exponent in der Eingangszahl "Input" 
 // ist jetzt: 0111111B = 126 oder 127.
 // Je nach dem verbliebenen Bit und inklusive 
 // Bias (s.o.) entspricht das gerade: "2^0" oder "2^-1"     // Input ist jetzt auf {0.5,2} normiert 
 
 Maske=(long unsigned *)&Wurzel;                             // Maske auf´s Zwischenergebnis auflegen
 
 // Iteration für die normierte Zahl
 for(i=0;i<4;i++)                                            // eine feste Anzahl von Iterationsschritten
 {	 Wurzel = ( Wurzel + Input/Wurzel );
	 *Maske-= (1<<23);
 }
 
 *Maske=(*Maske &0x7fffff)+(((*Maske>>23) + Exponent)<<22);  // Exponenten restaurieren
 // (
 // *Maske:       00111111Bbbbbbbbbbbbbbbbbbbbbbbb
 // &0x7fffffff:  00000000011111111111111111111111
 // (=):          000000000bbbbbbbbbbbbbbbbbbbbbbb
 // )
 // +
 // (
 // *Maske>>23:                          00111111B(bbbbbbbbbbbbbbbbbbbbbbb)
 // +Exponent:                    00000000BBBBBBBB
 // (=):                          0000000BBBBBBBB0  (*)
 // <<22: (000000)0BBBBBBBB00000000000000000000000
 // )
 // ______________________________________________
 //  =            0BBBBBBBBbbbbbbbbbbbbbbbbbbbbbbb
 // 
 // Der erste Term der Addition ist das Zwischenergebnis
 // mit gelöschtem Exponent
 // Für den zweiten Term wird das Zwischenergebnis wieder
 // 23 Bit nach rechts verschoben, sodas nur der 
 // Normexponent bleibt, und dieser wird mit dem 
 // Ursprünglichen Exponenten addiert. Das weicht etwas 
 // vom oben beschriebenen Algorithmus ab, 
 // warum, steht weiter unten.
 // (*) Dieser Term ist immer grade, weil das letzte
 // Bit vom Normexponent und vom Ursprungsexponent
 // identisch ist. Daher ist das letzte Bit des Terms
 // immer Null.
 // Der zweite Term muß noch halbiert und 23 Bits
 // weiter links addiert werden.
 // Eine Divison durch Zwei bei binären Ganzzahlen
 // entspricht einer 1 Bitverschiebung nach rechts.
 // Weil das letzte Bit immer Null ist (additionsneutral),
 // können die Schritte als Bit-Verschiebung um
 // (nur) 22 Bits nach links und Addition zum ersten Term
 // zusammengefasst werden, ohne die Mantisse zu verändern.
 // Diese leicht andere Restauration des Exponenten ist dem 
 // (genialen) Bias geschuldet.
 // Der Bias ist ein fester Wert der zu den Exponenten addiert
 // ist, sodas sie immer positiv sind. Bei "float" ist das 127.
 // ( http://de.wikipedia.org/wiki/Gleitkommazahl )
 // Ihn zu entfernen, auf das Vorzeichen des Ursprungsexponenten
 // zu prüfen, um "richtigrum" zu halbieren und wieder einzufügen,
 // kann mit folgender Umformung umgangen werden:
 //
 //neuer Exponent =  Normexponent + gerader,abgespaltener Teilexponent /2
 //               =  Normexponent + (Ursprungsexponent - Normexponent)/2
 //               = (Normexponent + Normexponent + Ursprungsexponent - Normexponent)/2
 //               = (Normexponent + Ursprungsexponent)/2
 
 return Wurzel;
 } 

